# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _charge
else:
    import _charge

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class IsoCurrent(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, kappa):
        _charge.IsoCurrent_swiginit(self, _charge.new_IsoCurrent(reg, name, kappa))
    __swig_destroy__ = _charge.delete_IsoCurrent

# Register IsoCurrent in _charge:
_charge.IsoCurrent_swigregister(IsoCurrent)
class AnisoCurrent(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, k):
        _charge.AnisoCurrent_swiginit(self, _charge.new_AnisoCurrent(reg, name, k))
    __swig_destroy__ = _charge.delete_AnisoCurrent

# Register AnisoCurrent in _charge:
_charge.AnisoCurrent_swigregister(AnisoCurrent)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.


# Very similar to the non-charged diffusion, but with Charge_Flux
# instead of Atom_Flux, and Voltage instead of Concentration.  Also,
# there is no "mobility" analog, and no surface property (yet?).

from ooflib.common import runtimeflags

from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

from ooflib.engine.IO import interfaceparameters

from ooflib.EXTENSIONS.diffusion import diff_problem


PropertyRegistration = propertyregistration.PropertyRegistration

## ISOTROPIC

reg = PropertyRegistration(
    'Migration:Charge:Isotropic',
    IsoCurrent,
    98,
    params=[parameter.FloatParameter('K',
                                     1.0, tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Isotropic charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## TRICLINIC

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Triclinic',
    AnisoCurrent,
    105,
    [symmmatrix.TriclinicRank2TensorParameter(
    'K',
    symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Triclinic charge diffusion"
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## MONOCLINIC

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Monoclinic',
    AnisoCurrent,
    104,
    [symmmatrix.MonoclinicRank2TensorParameter(
    'K',
    symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Monoclinic charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## ORTHORHOMBIC

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Orthorhombic',
    AnisoCurrent,
    103,
    [symmmatrix.OrthorhombicRank2TensorParameter(
    'K',
    symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Orthorhombic charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## TETRAGONAL

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Tetragonal',
    AnisoCurrent,
    101,
    [symmmatrix.TetragonalRank2TensorParameter(
    'K',
    symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Tetragonal charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## TRIGONAL

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Trigonal',
    AnisoCurrent,
    102,
    [symmmatrix.TrigonalRank2TensorParameter(
    'K',
    symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Trigonal charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## HEXAGONAL

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Hexagonal',
    AnisoCurrent,
    100,
    [symmmatrix.HexagonalRank2TensorParameter(
    'K',
    symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
    tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Hexagonal charge diffusion."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])


## CUBIC

reg = PropertyRegistration(
    'Migration:Charge:Anisotropic:Cubic',
    AnisoCurrent,
    99,
    [symmmatrix.CubicRank2TensorParameter(
            'K',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip=parameter.emptyTipString)],
    propertyType="Current",
    tip="Cubic charge diffusion."
)

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux],
             fields=[problem.Voltage],
             time_derivs=[0])





