# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _stressfreestrain
else:
    import _stressfreestrain

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class IsotropicStressFreeStrain(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, e):
        _stressfreestrain.IsotropicStressFreeStrain_swiginit(self, _stressfreestrain.new_IsotropicStressFreeStrain(reg, name, e))
    __swig_destroy__ = _stressfreestrain.delete_IsotropicStressFreeStrain

# Register IsotropicStressFreeStrain in _stressfreestrain:
_stressfreestrain.IsotropicStressFreeStrain_swigregister(IsotropicStressFreeStrain)
class AnisotropicStressFreeStrain(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, e):
        _stressfreestrain.AnisotropicStressFreeStrain_swiginit(self, _stressfreestrain.new_AnisotropicStressFreeStrain(reg, name, e))
    __swig_destroy__ = _stressfreestrain.delete_AnisotropicStressFreeStrain

# Register AnisotropicStressFreeStrain in _stressfreestrain:
_stressfreestrain.AnisotropicStressFreeStrain_swigregister(AnisotropicStressFreeStrain)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 


from ooflib.SWIG.engine import symmmatrix
from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import problem
from ooflib.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Isotropic',
    IsotropicStressFreeStrain,
    22,
    [parameter.FloatParameter('epsilon0', 0.0, tip="StressFreeStrain")],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Isotropic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/isostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Cubic',
    AnisotropicStressFreeStrain,
    23,
    [symmmatrix.CubicRank2TensorParameter(
            'epsilon0',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Cubic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Hexagonal',
    AnisotropicStressFreeStrain,
    24,
    [symmmatrix.HexagonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Hexagonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Trigonal',
    AnisotropicStressFreeStrain,
    25,
    [symmmatrix.TrigonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Trigonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Tetragonal',
    AnisotropicStressFreeStrain,
    26,
    [symmmatrix.TetragonalRank2TensorParameter(
            'epsilon0',
            symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Tetragonal stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Orthorhombic',
    AnisotropicStressFreeStrain,
    27,
    [symmmatrix.OrthorhombicRank2TensorParameter(
            'epsilon0',
            symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Orthorhombic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Monoclinic',
    AnisotropicStressFreeStrain,
    26,
    [symmmatrix.MonoclinicRank2TensorParameter(
            'epsilon0',
            symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Monoclinic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])

#########

reg = PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Triclinic',
    AnisotropicStressFreeStrain,
    26,
    [symmmatrix.TriclinicRank2TensorParameter(
            'epsilon0',
            symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip='Stress-free strain tensor')],
    outputs=["Strain", "Energy", "Material Constants:Mechanical:Stress-free Strain epsilon0"],
    propertyType="StressFreeStrain",
    tip="Triclinic stress-free strain",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisostressfreestrain.xml'))

reg.fluxInfo(fluxes=[problem.Stress])



